"""
Carlos J Corrada Bravo
Este programa calcula el promedio de tiempo de ejecucion de cuatro algoritmos de ordenamiento
La variable maxValor define el valor maximo de los elementos de la lista
La variable largoLista define el largo de las listas a ordenar
La variable veces define las veces que se va a hacer el ordenamiento
Al final se imprimen los promedios de cada algortimo
"""
from random import randint
import time

def mergeSort(lista):
	#definan el algoritmo de ordenamiento mergesort
	# If the size of the list is greater than 1 then it enters here
	if len(lista) > 1:
		# Gets the half of the list
		Midd = len(lista) / 2
		# Takes only the elements that are in the left of the list
		Left = lista[Midd:]
		# If the size of left still is not 1 then
		if len(Left) != 1:
			# it will do a recursive call to the function again
			mergeSort(Left)
		# Takes only the elements that are in the right of the list
		Right = lista[:Midd]
		# If the size of right still is not 1 then
		if len(Right) != 1:
			# it will do a recursive call to the function again
			mergeSort(Right)

		# Variables define for while and getting space in the list
        i = j = k = 0

		# While i and j are less than the comparation it enters here
        while i < len(Left) and j < len(Right):
			# If the compared number in i is less than j it enters here
            if Left[i] < Right[j]:
				# The less variable is stored in the list again in order
                lista[k] = Left[i]
                i += 1 # Increments i
			# If the compared number in i is greater than j it enters here
            else:
				# The less variable is stored in the list again in order
                lista[k] = Right[j]
                j += 1 # Increments j
            k += 1 # Increments k

		# If there are elements remaining in Left the they are put here
        while i < len(Left):
			# The variable that was remaining is put here
            lista[k] = Left[i]
            i += 1 # Increments i
            k += 1 # Increments k

		# If there are elements remaining in Right the they are put here
        while j < len(Right):
			# The variable that was remaining is put here
            lista[k] = Right[j]
            j += 1 # Increments j
            k += 1 # Increments k

	return lista
	# Code was base and taken from GeeksforGeeks

def heapSort(lista):
	#definan el algoritmo de ordenamiento heapsort
	return lista

def quickSort(lista):
	#definan el algoritmo de ordenamiento quicksort
	return lista

def shellSort(lista):
	#definan el algoritmo de ordenamiento shellsort
	return lista

maxValor=1000 	#define el valor maximo de los elementos de la lista
largoLista=1000 #define el largo de las listas a ordenar
veces=100 		#define las veces que se va a hacer el ordenamiento

acumulaMerge=0 	#variable para acumular el tiempo de ejecucion del mergesort
acumulaHeap=0 	#variable para acumular el tiempo de ejecucion del heapsort
acumulaQuick=0 	#variable para acumular el tiempo de ejecucion del quicksort
acumulaShell=0 	#variable para acumular el tiempo de ejecucion del shellsort

for i in range(veces):
	mergelista = [randint(0,maxValor) for r in range(largoLista)] #creamos una lista con valores al azar
	heaplista=list(mergelista)
	quicklista=list(mergelista)
	searchlista=list(mergelista)

	t1 = time.clock() 				#seteamos el tiempo al empezar
	mergeSort(mergelista) 				#ejecutamos el algoritmo mergeSort
	acumulaMerge+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

	t1 = time.clock()				#seteamos el tiempo al empezar
	heapSort(heaplista)					#ejecutamos el algoritmo heapSort
	acumulaHeap+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

	t1 = time.clock()				#seteamos el tiempo al empezar
	quickSort(quicklista)				#ejecutamos el algoritmo quickSort
	acumulaQuick+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

	t1 = time.clock()				#seteamos el tiempo al empezar
	shellSort(searchlista)				#ejecutamos el algoritmo shellSort
	acumulaShell+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

#imprimos los resultados
print "Promedio de tiempo de ejecucion de "+ str(veces) +" listas de largo " + str(largoLista)
print "MergeSort " + str(acumulaMerge/veces) + " segundos"
print "HeapSort " + str(acumulaHeap/veces) + " segundos"
print "QuickSort " + str(acumulaQuick/veces) + " segundos"
print "ShellSort " + str(acumulaShell/veces) + " segundos"
